local enm = {}

local enemies = {}

function enm.newEnemy(id, x, y)
    local enemy = {}

    enemy.id = id
    enemy.x = x
    enemy.y = y
    enemy.a = 0
    enemy.dx, enemy.dy = 0, 0

    enemy.vx = 0
    enemy.vy = 0
    enemy.maxv = 3
    enemy.aceleratio = enemy.maxv * .5

    enemy.ray = 20
    enemy.viewRay = math.random(100, 210)
    enemy.view = enemy.viewRay
    enemy.facing = false

    if tonumber(#enemies) <= 200 then
        enemy.removed = false
    else
        enemy.removed = true
    end
    table.insert(enemies, enemy)
end

function enm.update(dt)
    for i = #enemies, 1, -1 do
        local enemy = enemies[i]
        if not enemy.removed == true then
            enemy.dx, enemy.dy = math.cos(enemy.a) ,math.sin(enemy.a)

            if enemy.facing then
                enemy.viewRay = 400
            else
                enemy.viewRay = enemy.view
            end

            -- behavior of enemies
            enemy.x = enemy.x + enemy.vx
            enemy.y = enemy.y + enemy.vy

            if (math.sqrt((plr.x - enemy.x) ^ 2 + (plr.y - enemy.y) ^ 2) <= plr.ray + enemy.viewRay) and (math.atan2(plr.y-enemy.y, plr.x-enemy.x) > enemy.a -.5236 and math.atan2(plr.y-enemy.y, plr.x-enemy.x) < enemy.a+.5236) then
                enemy.facing = true
                if math.atan2(plr.y-enemy.y, plr.x-enemy.x) >= enemy.a then
                    enemy.a = enemy.a + .0349 
                else
                    enemy.a = enemy.a - .0349 
                end

                if plr.x > enemy.x then
                    if enemy.vx < enemy.maxv then
                        enemy.vx = enemy.vx + enemy.aceleratio * dt
                    else enemy.vx = enemy.maxv end
                else
                    if enemy.vx > 0 then
                        enemy.vx = enemy.vx - enemy.vx * .1
                    end
                end
                if plr.x < enemy.x then
                    if enemy.vx > -enemy.maxv then
                        enemy.vx = enemy.vx - enemy.aceleratio * dt
                    else enemy.vx = -enemy.maxv end
                else
                    if enemy.vx < 0 then
                        enemy.vx = enemy.vx - enemy.vx * .1
                    end
                end

                if plr.y < enemy.y then
                    if enemy.vy > -enemy.maxv then
                        enemy.vy = enemy.vy - enemy.aceleratio * dt
                    else enemy.vy = -enemy.maxv end
                else
                    if enemy.vy < 0 then
                        enemy.vy = enemy.vy - enemy.vy * .1
                    end
                end
                if plr.y > enemy.y then
                    if enemy.vy < enemy.maxv then
                        enemy.vy = enemy.vy + enemy.aceleratio * dt
                    else enemy.vy = enemy.maxv end
                else
                    if enemy.vy > 0 then
                        enemy.vy = enemy.vy - enemy.vy * .1
                    end
                end
            else
                enemy.facing = false
                enemy.vx = enemy.vx - enemy.vx * .1
                enemy.vy = enemy.vy - enemy.vy * .1
                local t = 0
                t = t +dt
                if t > 1 then
                    t = 0
                    enemy.a = math.random(0, 7)
                end
            end

            if math.sqrt((plr.x - enemy.x) ^ 2 + (plr.y - enemy.y) ^ 2) <= plr.ray + enemy.ray then
                table.remove(enemies, i)
            end
        else
            table.remove(enemies, i)
        end
    end
end

function enm.draw()
    for i = #enemies, 1, -1 do
        local enemy = enemies[i]
        love.graphics.setColor(1, 1, 1, .3)
        love.graphics.circle("line", enemy.x, enemy.y, enemy.ray + 20)
        love.graphics.setColor(0, 0, 0)
        love.graphics.circle("line", enemy.x, enemy.y, enemy.ray)
        love.graphics.setColor(1, 1, 1)
        love.graphics.circle("line", enemy.x, enemy.y, enemy.viewRay)
        
        love.graphics.line(enemy.x, enemy.y, enemy.x+enemy.dx*enemy.viewRay, enemy.y+enemy.dy*enemy.viewRay)
        love.graphics.setColor(1,1,0)

        love.graphics.line(enemy.x, enemy.y, enemy.x+math.cos(enemy.a-.5236)*enemy.viewRay, enemy.y+math.sin(enemy.a-.5236)*enemy.viewRay)
        love.graphics.line(enemy.x, enemy.y, enemy.x+math.cos(enemy.a+.5236)*enemy.viewRay, enemy.y+math.sin(enemy.a+.5236)*enemy.viewRay)
        love.graphics.line(enemy.x, enemy.y, enemy.x+math.cos(math.atan2(plr.y-enemy.y, plr.x-enemy.x))*25, enemy.y+math.sin(math.atan2(plr.y-enemy.y, plr.x-enemy.x))*25)
    end
end

return enm
