local player = {}

function player.load()
    plr = {}
    
    plr.x = 200
    plr.y = 200
    plr.vx = 0
    plr.vy = 0
    plr.maxv = 4
    plr.aceleratio = 4*plr.maxv

    plr.ray = 20
end

function player.draw()
    love.graphics.setColor(1,1,1,.3)
    love.graphics.circle('fill', plr.x, plr.y, plr.ray)
    love.graphics.setColor(1,1,1)
    love.graphics.circle('line', plr.x, plr.y, plr.ray)
end

function player.update(dt)
    plr.x = plr.x + plr.vx
    plr.y = plr.y + plr.vy

    if love.keyboard.isDown("d", "right") then
        if plr.vx < plr.maxv then 
            plr.vx = plr.vx + plr.aceleratio * dt
        else
            plr.vx = plr.maxv
        end
    else
        if plr.vx > 0 then 
            plr.vx = plr.vx - plr.vx * .1
        end
    end
    if love.keyboard.isDown("a", "left") then
        if plr.vx > -plr.maxv then 
            plr.vx = plr.vx - plr.aceleratio * dt
        else
            plr.vx = -plr.maxv
        end
    else
        if plr.vx < 0 then 
            plr.vx = plr.vx - plr.vx * .1
        end
    end

    if love.keyboard.isDown("w", "up") then
        if plr.vy > -plr.maxv then 
            plr.vy = plr.vy - plr.aceleratio * dt
        else
            plr.vy = -plr.maxv
        end
    else
        if plr.vy < 0 then 
            plr.vy = plr.vy - plr.vy * .1
        end
    end
    if love.keyboard.isDown("s", "down") then
        if plr.vy < plr.maxv then 
            plr.vy = plr.vy + plr.aceleratio * dt
        else
            plr.vy = plr.maxv
        end
    else
        if plr.vy > 0 then 
            plr.vy = plr.vy - plr.vy * .1
        end
    end
end

return player